    View Javadoc
    1   package org.apache.bcel.classfile;
    2
    3   /* ====================================================================
    4    * The Apache Software License, Version 1.1
    5    *
    6    * Copyright (c) 2001 The Apache Software Foundation.  All rights
    7    * reserved.
    8    *
    9    * Redistribution and use in source and binary forms, with or without
    10   * modification, are permitted provided that the following conditions
    11   * are met:
    12   *
    13   * 1. Redistributions of source code must retain the above copyright
    14   *    notice, this list of conditions and the following disclaimer.
    15   *
    16   * 2. Redistributions in binary form must reproduce the above copyright
    17   *    notice, this list of conditions and the following disclaimer in
    18   *    the documentation and/or other materials provided with the
    19   *    distribution.
    20   *
    21   * 3. The end-user documentation included with the redistribution,
    22   *    if any, must include the following acknowledgment:
    23   *       "This product includes software developed by the
    24   *        Apache Software Foundation (http://www.apache.org/)."
    25   *    Alternately, this acknowledgment may appear in the software itself,
    26   *    if and wherever such third-party acknowledgments normally appear.
    27   *
    28   * 4. The names "Apache" and "Apache Software Foundation" and
    29   *    "Apache BCEL" must not be used to endorse or promote products
    30   *    derived from this software without prior written permission. For
    31   *    written permission, please contact apache@apache.org.
    32   *
    33   * 5. Products derived from this software may not be called "Apache",
    34   *    "Apache BCEL", nor may "Apache" appear in their name, without
    35   *    prior written permission of the Apache Software Foundation.
    36   *
    37   * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
    38   * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
    39   * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
    40   * DISCLAIMED.  IN NO EVENT SHALL THE APACHE SOFTWARE FOUNDATION OR
    41   * ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
    42   * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
    43   * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
    44   * USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
    45   * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
    46   * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
    47   * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    48   * SUCH DAMAGE.
    49   * ====================================================================
    50   *
    51   * This software consists of voluntary contributions made by many
    52   * individuals on behalf of the Apache Software Foundation.  For more
    53   * information on the Apache Software Foundation, please see
    54   * <http://www.apache.org/>;.
    55   */
    56
    57  import  org.apache.bcel.Constants;
    58  import  java.io.*;
    59
    60  /***
    61   * This class is derived from the abstract
    62   * <A HREF="org.apache.bcel.classfile.Constant.html">Constant</A> class
    63   * and represents a reference to a String object.
    64   *
    65   * @version $Id: ConstantString.java,v 1.2 2002/03/11 16:16:35 mdahm Exp $
    66   * @author  <A HREF="mailto:markus.dahm@berlin.de">M. Dahm</A>
    67   * @see     Constant
    68   */
    69  public final class ConstantString extends Constant implements ConstantObject {
    70    private int string_index; // Identical to ConstantClass except for this name
    71
    72    /***
    73     * Initialize from another object.
    74     */
    75    public ConstantString(ConstantString c) {
    76      this(c.getStringIndex());
    77    }
    78    /***
    79     * Initialize instance from file data.
    80     *
    81     * @param file Input stream
    82     * @throws IOException
    83     */
    84    ConstantString(DataInputStream file) throws IOException
    85    {
    86      this((int)file.readUnsignedShort());
    87    }
    88    /***
    89     * @param string_index Index of Constant_Utf8 in constant pool
    90     */
    91    public ConstantString(int string_index)
    92    {
    93      super(Constants.CONSTANT_String);
    94      this.string_index = string_index;
    95    }
    96    /***
    97     * Called by objects that are traversing the nodes of the tree implicitely
    98     * defined by the contents of a Java class. I.e., the hierarchy of methods,
    99     * fields, attributes, etc. spawns a tree of objects.
    100    *
    101    * @param v Visitor object
    102    */
    103   public void accept(Visitor v) {
    104     v.visitConstantString(this);
    105   }
    106   /***
    107    * Dump constant field reference to file stream in binary format.
    108    *
    109    * @param file Output file stream
    110    * @throws IOException
    111    */
    112   public final void dump(DataOutputStream file) throws IOException
    113   {
    114     file.writeByte(tag);
    115     file.writeShort(string_index);
    116   }
    117   /***
    118    * @return Index in constant pool of the string (ConstantUtf8).
    119    */
    120   public final int getStringIndex() { return string_index; }
    121   /***
    122    * @param string_index.
    123    */
    124   public final void setStringIndex(int string_index) {
    125     this.string_index = string_index;
    126   }
    127   /***
    128    * @return String representation.
    129    */
    130   public final String toString()
    131   {
    132     return super.toString() + "(string_index = " + string_index + ")";
    133   }
    134
    135   /*** @return String object
    136    */
    137   public Object getConstantValue(ConstantPool cp) {
    138     Constant c = cp.getConstant(string_index, Constants.CONSTANT_Utf8);
    139     return ((ConstantUtf8)c).getBytes();
    140   }
    141
    142   /*** @return dereferenced string
    143    */
    144   public String getBytes(ConstantPool cp) {
    145     return (String)getConstantValue(cp);
    146   }
    147 }

This page was automatically generated by Maven